﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module v.1.02F
'*************************************************************
'Try to find the location of removable external sdcard memory.
'*************************************************************
Sub Class_Globals
	Dim m As List
	Dim SDf,words() As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	m.Initialize
	
End Sub

Sub Initializes(storage As String) As String
	m.Initialize
	Return storage
End Sub

Public Sub DeviceStorage As String
  	'---------------------------------
	' Device storage: Samsung S3
	'---------------------------------
	m.Initialize
	m.Add("/mnt,sdcard")
	m.Add("/sdcard,")
	m.Add("/storage,emulated/0")
	m.Add("/storage,sdcard0")
	'---------------------------------
	If m.Size > 0 Then
		For i=0 To m.Size -1
			words = Regex.Split(",", m.Get(i))
  			SDf = TryExternalSD(words(0),words(1))
  			If SDf <> "" Then Initializes(SDf)
		Next
	End If
	Return File.DirRootExternal
	'---------------------------------
End Sub

Public Sub SDMemoryCard As String
  	'---------------------------------
	' SD memory card: Samsung S3
	'---------------------------------
	m.Initialize
	m.Add("/mnt,extSdCard")
	m.Add("/mnt,external_sd")
	m.Add("/storage,extSdCard")
	'---------------------------------
	If m.Size > 0 Then
		For i=0 To m.Size -1
			words = Regex.Split(",", m.Get(i))
  			SDf = TryExternalSD(words(0),words(1))
  			If SDf <> "" Then Initializes(SDf)
		Next
	End If
	Return File.DirRootExternal
	'---------------------------------
End Sub

Sub TryExternalSD(root As String, folder As String) As String
    Dim SDf As String = ""
    If File.IsDirectory(root,folder) Then
       SDf = root & "/" & folder
  	End If
	Return SDf
End Sub

'--------------------------------------------------------------------------- getExternalFilesDirs ----------------------------
'Dim extpaths() As Object
'Example: extpaths = GetExternalFilesDirs("getExternalFilesDirs")
'-----------------------------------------------------------------------------------------------------------------------------
public Sub GetExternalFilesDirs(ExternalFilesDirs As String) As Object
   	Dim paths() As Object = GetContext.RunMethod(ExternalFilesDirs, Array(Null))
   	'For Each p As Object In paths
    '	Log(p)
   	'Next
	Return paths
End Sub

Sub GetContext As JavaObject
  	Return GetBA.GetField("context")
End Sub

Sub GetBA As JavaObject
  	Dim jo As JavaObject
  	Dim cls As String = Me
  	cls = cls.SubString("class ".Length)
  	jo.InitializeStatic(cls)
  	Return jo.GetFieldJO("processBA")
End Sub